﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.3
@EndOfDesignText@
' B4J Spinner

' Uses a canvas to allow use of image and mouse dragged and click events
' Spinner position can be changed by dragging or by clicking top or bottom sections
' Each of the three sections of the Spinner image should be 1/3 of the height

' Lots of alterations and enhancements can be made!

Sub Class_Globals
	'For use with callsub back to the activity, not used here
	Private mModule As Object     					
	Private mEventName As String
	'----------------------------------------------------------------
	Private fx As JFX
	Private cvs1 As Canvas
	Private SpinnerImage As Image
	Private Info() As String						' Spinner info	
	
	'Array index of spinner center returned to activity
	Public Index As Int                           	
		
	'These items could be changed to public to allow defining with spinner in the activity
	Private OuterColor As Paint
	Private OuterFont As Font
	Private MidFont As Font
	Private MidColor As Paint
	'---------------------------------------------------------------------
	'Mouse controls
	'OldIndex  and Change stops multiple firing of AdjustIndex for
	'mouse drags when the spinner does not change due to the scan delay
	Private OldMouseY As Int
	Private Change As Boolean
	Private OldIndex As Int
	Private ScanTime As Int = 275						'Update time, adjust to liking 
End Sub


' Initializes the Spinner
' Images are self adjusting to size of the canvas
' Change text colour and image to your own liking or put as public global for use in activity
Public Sub Initialize (pModule As Object,pEventName As String,pFrm As Form,pLeft As Int, pTop As Int, pwidth As Int, pHeight As Int, pValues() As String)
	mModule=pModule                   ' for use with callsub back to the activity
	mEventName=pEventName             ' for use with callsub back to the activity   
	cvs1.Initialize("CVS1")
	pFrm.RootPane.AddNode(cvs1,pLeft,pTop,pwidth,pHeight)
	SpinnerImage =fx.LoadImageSample(File.DirAssets, "BlackSpinner.png",pwidth,pHeight)
	OuterColor =fx.colors.LightGray
	OuterFont  = fx.DefaultFont(17)
	MidColor = fx.Colors.White
	MidFont  = fx.DefaultFont(25)
	Info=pValues
	Index=0
	ShowSpinner(Info(Info.Length-1),Info(Index),Info(Index+1))        ' sets first spinner location
End Sub

' Sets the visibility of the spinner
Public Sub Visibility(vis As Boolean)
	If vis= True Then
		cvs1.Visible=True
	Else
		cvs1.Visible=False
	End If
End Sub

' shows the Spinner
Private Sub ShowSpinner (TopTxt As String,MidTxt As String,BotTxt As String)
	cvs1.ClearRect(0,0,cvs1.Width,cvs1.Height)
	cvs1.DrawImage(SpinnerImage,0,0, SpinnerImage.Width,SpinnerImage.Height)
	cvs1.DrawText(TopTxt,cvs1.Width/2,0.2*cvs1.Height,OuterFont,OuterColor,"CENTER")
	cvs1.DrawText(MidTxt,cvs1.Width/2,0.55*cvs1.Height,MidFont,MidColor,"CENTER")
	cvs1.DrawText(BotTxt,cvs1.Width/2,0.85*cvs1.Height,OuterFont,OuterColor,"CENTER")
End Sub

'Ajusts the index to allow continous rotation through the array presented
Private Sub AdjustIndex
	Dim TopTxt,MidTxt,BotTxt As String
	If Index >Info.Length-1 Then
		Index = 0
	End If
	
	If Index <0 Then
		Index = Info.Length-1
	End If
	
	If Index = 0 Then
		TopTxt=Info(Info.Length-1)
	Else
		TopTxt = Info(Index-1)
	End If
	
	MidTxt= Info(Index)
	
	If Index = Info.Length-1 Then
		BotTxt=Info(0)
	Else
		BotTxt =Info(Index+1)
	End If
	Sleep(ScanTime)                                   ' defines the scan update time
	ShowSpinner(TopTxt,MidTxt,BotTxt)                 ' displays new items in wheel
	Change=False									  ' resets control to the mouse		
End Sub


'Adjusts the index according to the mouse drag
Private Sub cvs1_MouseDragged (EventData As MouseEvent)
	EventData.Consume
	If EventData.Y> OldMouseY And Change=False Then
		Index=Index-1
		Change=True
	End If
	If EventData.Y<OldMouseY And Change=False Then
		Index = Index+1
		Change=True
 	End If
 	If Change= True And OldIndex<>Index Then
		AdjustIndex
		OldMouseY=EventData.Y
		OldIndex=Index
	End If
End Sub

'Increments or decrements index on mouse click to the top or
'bottom third of spinner
Private Sub cvs1_MousePressed (EventData As MouseEvent)
	If EventData.Y<0.33 * cvs1.Height Then
		Index=Index-1
	End If
	If EventData.Y>0.66 * cvs1.Height Then
		Index=Index+1
	End If
	AdjustIndex
End Sub

